;|
AutoLisp-module for MtmdAcadTabs
It should reside in the same folder with MtmdAcadTabsXXX.arx

mtmdsettabtext function is used for setting caption of current drawing tab:
(mtmdsettabtext "Your_caption")
or
(mtmdsettabtext (getvar "DWGNAME"))

You can customize mtmdsettabfn function (see below)

See also example of SetTabTextfromDB function, that gets text for caption from SQL database
(it's useful if you use some kind of document management system)
You will need to adapt it to you DB, obviously

;----------------------------------
; ADO initialization
; for DB-access
;----------------------------------
(defun pdmInitADO ()
  (if (equal nil adoc-adOpenDynamic) ; check for a ADO constant
    (vlax-import-type-library
;; please check for valid version of msado-library on you system
      :tlb-filename "C:/Program Files/Common Files/System/ado/msado15.dll"
      :methods-prefix "adom-"
      :properties-prefix "adop-"
      :constants-prefix "adoc-"
    )
  )
);defun

(defun SetTabTextfromDB ( / path fname docfname res flds connstr strsql query fnamebase filever)
  (setq fname (getvar "DWGNAME"))
  (if (= (getvar "DWGPREFIX") "F:\\PDM\\")
    (progn
      (setq fnamebase (vl-filename-base fname))
      (setq filever (substr fnamebase (1- (strlen fnamebase)) 2))
      (setq docfname
        (strcat
          (substr fnamebase 1 (- (strlen fnamebase) 2))
          (vl-filename-extension fname)
        )
      )
      (pdmInitADO)
      (setq connstr "Provider=MSDASQL.1;Password=sql;Persist Security Info=True;User ID=dba;Data Source=PDM")
      (setq connstr (vlax-make-variant connstr))
      (setq strsql (strcat "select description from File_V where file_name = '" docfname "'"))
      (setq strsql (vlax-make-variant strsql))
      (setq query (vlax-create-object "ADODB.Recordset"))
      (adom-Open query strsql connstr -1 -1 -1)
      (setq flds (adop-get-Fields query))

      (mtmdsettabtext (strcat (ado-getfield flds "description") " #" filever
        (if (= (getvar "WRITESTAT") 0) " [RO]" "")
      ))

      (vlax-release-object flds)
      (vlax-release-object query)
      (setq query nil)
    );progn
    (mtmdsettabtext (strcat (getvar "DWGNAME") (if (= (getvar "WRITESTAT") 0) " [RO]" "")))
  );if
)
|;

;Custom commands in tab's context menu:
(mtmdaddtabmenuitem "Save" "_QSAVE\n")
(mtmdaddtabmenuitem "Close" "_CLOSE\n")
;----------------------------------
(vl-load-com)
(defun ado-getfield (fields fieldname)
  (vlax-variant-value (adop-get-Value (adop-get-Item fields (vlax-make-variant fieldname))))
)
;----------------------------------
; Setting tab caption
;----------------------------------
(defun mtmdsettabfn ()
;; you can customize next line
  (mtmdsettabtext (strcat (getvar "DWGNAME") (if (= (getvar "WRITESTAT") 0) " [RO]" "")))
; or comment out previous line and set caption from database 
;	(SetTabTextfromDB)
)
;----------------------------------
(defun mtmdtabssavefn (calling-reactor commandInfo / dwg)
  (setq dwg (cadr commandInfo))
  (if (and (/= (getvar "cmdnames") "") (/= dwg mtmdtabdwgname))
    (progn
      (mtmdsettabfn)
      (setq mtmdtabdwgname dwg)
    )
  )
)
;------------------------
(setq mtmdtabdwgname "")

(defun mtmdtabclosefn (calling-reactor commandInfo)
  (vlr-remove *mtmdtabcloseReac*)
  (vlr-remove *mtmdtabsaveReac*)
  (setq *mtmdtabsaveReac* nil)
  (setq *mtmdtabcloseReac* nil)
);defun

(if (not *mtmdtabcloseReac*) (setq *mtmdtabcloseReac* (vlr-dwg-Reactor nil '((:vlr-beginClose . mtmdtabclosefn)))))
(if (not *mtmdtabsaveReac*) (setq *mtmdtabsaveReac* (vlr-dwg-Reactor nil '((:vlr-saveComplete . mtmdtabssavefn)))))

(mtmdsettabfn)

(princ "\nMtmdAcadTabs.lsp loaded")
(princ)
